//+------------------------------------------------------------------+
//|                                            DynamicRange.mq4      |
//|                                  Copyright  2006, Michel        |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Michel"

#property indicator_chart_window
#property indicator_buffers 2 

#property indicator_color1 DeepSkyBlue 
#property indicator_color2 DarkOrange

extern int Refresh = 1440;        // any number of minutes between 1 and 1440; history M1 must be loaded

double HiBand[], LoBand[], high, low; 
int    i, limit, counted_bars, BarCount, BarStart, BarEnd; 
datetime StartTime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init()
{
   IndicatorBuffers(2); 
   IndicatorShortName("DynamicRange");

   SetIndexBuffer(0,HiBand);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);    
   SetIndexLabel(0,"High Band");  
    
   SetIndexBuffer(1,LoBand);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);    
   SetIndexLabel(1,"Low Band");  
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start()
{
  //---- check for possible errors 
      counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1); 
  //---- last counted bar will be recounted 
      if(counted_bars>0) counted_bars--; 
      limit=Bars-counted_bars; 

  //---- main loop 
   for(i = limit ;i >= 0; i --) 
   { 
      StartTime = MathFloor((Time[i]) / (Refresh*60)) * Refresh*60;   
      
      BarStart = iBarShift(NULL,1,StartTime,false);
      if(i == 0) BarEnd = 0;
      else BarEnd = iBarShift(NULL,1,Time[i],false);    //value at the close of the bar
      BarCount = BarStart - BarEnd + 1;
      
      HiBand[i] = iHigh(NULL,1,iHighest(NULL,1,MODE_HIGH,BarCount,BarEnd));     
      LoBand[i] = iLow(NULL,1,iLowest(NULL,1,MODE_LOW,BarCount,BarEnd));    
   }
}
//+------------------------------------------------------------------+